#ifndef EG_COMMON_H
#define EG_COMMON_H

#ifdef UNIX_X
#include "libmfl.h"
#endif

#if defined(__INTEL__) || defined(UNIX_X)

#ifndef UNIX_X
	#define EG_WIN		1
	#define EG_WIN32	1
#endif

	#ifndef true
	#define true -1
	#define false 0
	#endif

	#ifndef NULL
	#define NULL 0L
	#endif
	
	struct Rect {
		short left, top, right, bottom;
	};
	#define Rect_Defined

	typedef long KeyMap[4];
	
	struct Point {
		short v, h;
	};
		
	struct RGBColor {
		unsigned short red, green, blue;
	};

#if EG_WIN
	#define __winRGB( r, g, b )  (( r >> 8 ) | ( g & 0xFF00 ) | (( b & 0xFF00 ) << 8 ))

	typedef HBITMAP		PixMapHandle;
	typedef HDC			GrafPtr;
	typedef HDC			CGrafPtr;
	typedef HWND		WindowPtr;
	typedef HDC			GWorldPtr;
	typedef HDC			BitMap;
 #else
/* FIXME */
	typedef void *		PixMapHandle;
	typedef void *			GrafPtr;
	typedef void *			CGrafPtr;
	typedef void *		WindowPtr;
	typedef mfl_context		GWorldPtr;
	typedef void *			BitMap;
 #endif

	struct ColorSpec {
		short		value;
		RGBColor	rgb;
	};


#else


	#define EG_MAC	1 
#endif

struct LongRect {
	long left, top, right, bottom;
};


#endif

