// G-Force for Unix base stuff

#include <stdlib.h>
#include <stdio.h>

#include "G-Force_Proj.h"

#include "G-Force.h"
#include "EgOSUtils.h"
#include "RectUtils.h"
#include "CEgFileSpec.h"

#include "libxpce.h"
#include "gUnixBase.h"

#define SND_BUF_SIZE 550

static GForce*		gGF = NULL;
static UtilStr*		gCurWinTitle = NULL;
static float		gSoundBuf[ SND_BUF_SIZE ];
char				gInitialDir[ 502 ];
long				gInitialDirLen;
long				gLastTitleCheck = -1;
int                     numsamp = 0;

extern "C" int Init() 
{
	EgOSUtils::Initialize( 0 );
	ScreenDevice::sMinDepth = 8;		

	gGF = new GForce;
	gCurWinTitle = new UtilStr;
	

	Rect r;
	SetRect( &r, 0, 0, xpce_GetWidth(), xpce_GetHeight() );
       	gGF -> SetWinPort(0, &r);
	gGF -> StoreWinRect(); 
}

extern "C" void UploadSamples(signed short *data, unsigned int n)
{
	long i;
	
	for ( i = 0; i < n; i++ ) {
	  gSoundBuf[ i ] = data[i];
	}
	numsamp = n;
}

extern "C" void Render() {
	long time = EgOSUtils::CurTimeMS();

	gGF -> RecordSample( time, gSoundBuf, .000023, numsamp );
}	


// cleanup (opposite of init()). Destroys the window, unregisters the window class
extern "C" void Quit(void)
{
	if ( gGF ) { /*
		RECT wr;
		::GetClientRect( gGF_Win, &wr );
		UtilStr str;
		str.Append( wr.top );
		str.Append( "  " );
				str.Append( wr.left );
		str.Append( "  " );
				str.Append( wr.bottom );
		str.Append( "  " );
				str.Append( wr.right );
		str.Append( "  " );
		EgOSUtils::ShowMsg( str ); */
	  
	        delete gGF;		
	        gGF = NULL;
		
		delete gCurWinTitle;
		gCurWinTitle = NULL;
	}
      	EgOSUtils::Shutdown();
}

extern "C" void xpceC_HandleResize(unsigned int w, unsigned int h) {
  if ( gGF ) {
    Rect r;
    SetRect( &r, 0, 0, w, h );
    /* gGF -> GetWinRect( r ); */
    gGF -> SetWinPort( 0 /* hwnd */, &r );
  }
}

extern "C" void xpceC_HandleInputChar(int c) {
  if (gGF) {
    gGF -> HandleKey(c);
  }
}

// We aren't interested in keysyms that don't resolve to characters
extern "C" void xpceC_HandleInputKeySym(int k) {}

#if 0
// window procedure for our window
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static long sLastClickTime = 0;
	MSG msg;

	switch ( message )
	{

		case WM_RBUTTONDOWN:
		case WM_LBUTTONDOWN:
			if ( gGF -> IsFullscreen() )
				gGF -> SetFullscreen( false );
			else if ( message == WM_LBUTTONDOWN ) {
				long curTime = EgOSUtils::CurTimeMS();
				if ( curTime - 200 < sLastClickTime )
					gGF -> SetFullscreen( true );
				else
					sLastClickTime = curTime;
			}
			return 0;	
			break;
	
		case WM_DESTROY: 
			if ( gGF )
				gGF -> StoreWinRect();
			PostQuitMessage(0); 
			return 0;

		case WM_KEYDOWN:
			if ( ::PeekMessage( &msg, hwnd, WM_CHAR, WM_CHAR, PM_NOREMOVE ) ) {
				if ( gGF -> HandleKey( (unsigned long) (0xFF & msg.wParam) ) ) {
					return 0;
				}
			}
		case WM_KEYUP:
			{	// get this_mod from our window's user data
				winampVisModule *this_mod = (winampVisModule *) GetWindowLong(hwnd,GWL_USERDATA);
				PostMessage(this_mod->hwndParent,message,wParam,lParam);
			}
		return 0;
			

	}
	return DefWindowProc(hwnd,message,wParam,lParam);
}
#endif
